.386
.model	flat, stdcall
option	casemap :none   ; case sensitive

Include	CPL.inc
Include DlgColor.asm

.CODE

start:
	Invoke InitCommonControls
	Invoke GetModuleHandle, NULL
	mov	hInstance, eax
	Invoke InitCLPGCtrl
	Invoke DialogBoxParam, hInstance, 101, 0, ADDR DlgProc, 0
	Invoke ExitProcess, eax

; -----------------------------------------------------------------------
DlgProc	proc	hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

Local hCtrl:DWORD
Local col:CPLG_FORECOLORS

	.if uMsg == WM_INITDIALOG
		Invoke CreateFontBold,hWin,IDC_IDCANCEL
		mov hFont1,eax
		Invoke SetControlFont,hWin,IDC_IDCANCEL
		Invoke SetControlFont,hWin,IDC_IDWORK
		Invoke SetControlFont,hWin,IDC_GROUPBOX1052
		Invoke SetControlFont,hWin,IDC_GROUPBOX1065
		Invoke SetControlFont,hWin,IDC_GROUPBOX1061
		Invoke SendDlgItemMessage,hWin,1070,WM_CLPG_SET_FONT,0,Addr szFont2
		Invoke SendDlgItemMessage,hWin,1068,WM_CLPG_SET_FONT,0,Addr szFont1
		Invoke SendDlgItemMessage,hWin,1066,WM_CLPG_SET_COLOR000,0,ColorsLightGoldenrodYellow
		Invoke SendDlgItemMessage,hWin,1066,WM_CLPG_SET_COLOR050,0,ColorsGoldenrod
		Invoke SendDlgItemMessage,hWin,1066,WM_CLPG_SET_COLOR100,0,ColorsDarkGoldenrod
		Invoke SendDlgItemMessage,hWin,1010,WM_CLPG_SET_RANGE,-1000,100
		Invoke SendDlgItemMessage,hWin,1010,WM_CLPG_SET_STEP,0,6
		Invoke SendDlgItemMessage,hWin,1010,WM_CLPG_SET_FONTSIZE,0,80
		Invoke SendDlgItemMessage,hWin,1010,WM_CLPG_SET_FONT,0,Addr szFont
		Invoke SetTimer,hWin,1,20,ADDR TimerProc
		mov TimerID,eax

	.elseif	uMsg == WM_COMMAND
        .if	wParam == IDC_IDCANCEL
			Invoke EndDialog,hWin,0
		.elseif wParam == IDC_IDWORK
		;-- Do smething to get the CPU busy
			Invoke GetDlgItem,hWin,IDC_IDWORK
			mov hCtrl,eax		
			Invoke EnableWindow,hCtrl,FALSE
			mov ecx,0fffffffh
			@@:
			test ecx,ecx
			jz @F
			dec ecx
			jmp @B
			@@:
			Invoke EnableWindow,hCtrl,TRUE
			
		.elseif wParam == IDC_Colors
		;-- pass hWnd of cpuload control to dialogbox to get access to it
			invoke GetDlgItem,hWin,IDC_CPULOAD1008
			Invoke DialogBoxParam,hInstance,102,hWin,ADDR DlgColor,eax

		.elseif wParam == IDC_Colors1012
		;-- Set customized forecolors
			invoke GetDlgItem,hWin,IDC_CPULOAD1009
			Invoke DialogBoxParam,hInstance,102,hWin,ADDR DlgColor,eax
			
		.elseif wParam == IDC_Colors3
			invoke GetDlgItem,hWin,IDC_CPULOAD1010
			Invoke DialogBoxParam,hInstance,102,hWin,ADDR DlgColor,eax
			
;		.elseif wParam == IDC_Font
;			Invoke SendDlgItemMessage,hWin,IDC_CPULOAD1010,WM_CLPG_SET_FONT,0,ADDR szFont
			
		.endif
	.elseif	uMsg == WM_CLOSE
		Invoke KillTimer,hWin,TimerID
		invoke DeleteObject,hFont1
		Invoke EndDialog,hWin,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp

TimerProc proc USES ebx hWnd:DWORD, uMsg:DWORD, idEvent:DWORD, dwTime:DWORD

	mov eax,dwCounter
	.if eax < 100
		add dwCounter,1
	.else
	    sub dwCounter,100
	.endif
	Invoke SendDlgItemMessage,hWnd,1010,WM_CLPG_STEPIT,0,TRUE
	Invoke SendDlgItemMessage,hWnd,1064,WM_CLPG_SET_NEWVALUE,0,dwCounter
	Invoke SendDlgItemMessage,hWnd,1066,WM_CLPG_SET_NEWVALUE,0,dwCounter
	Invoke SendDlgItemMessage,hWnd,1067,WM_CLPG_SET_NEWVALUE,0,dwCounter
	Invoke SendDlgItemMessage,hWnd,1069,WM_CLPG_SET_NEWVALUE,0,dwCounter
	Invoke SendDlgItemMessage,hWnd,1070,WM_CLPG_SET_NEWVALUE,0,dwCounter
	
	Ret
TimerProc EndP

end start