Include	windows.inc
Include GdipInc.inc
Include \masm32\macros\ucmacros.asm
Include \masm32\macros\macros.asm
Include	PDH_struc.inc
Include CpuLoad.inc
Include F:\masm32\m32lib\masm32.inc
Include LogWrite.inc

IncludeLib F:\masm32\m32lib\masm32.lib


uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM

uselib user32
uselib kernel32
uselib gdi32
uselib advapi32
uselib pdh
uselib gdiplus
;uselib masm32

; prototypes --------------------------------------------------

; procs for CpuLoadStyle
_InitPdhCounter    PROTO :DWORD
_CleanupPdhCounter PROTO :DWORD
TimerProcNT	       PROTO :DWORD,:DWORD,:DWORD,:DWORD
; general drawing procs
InitGDIp           PROTO :DWORD
CleanUpGDIp        PROTO :DWORD
InitFont           PROTO :DWORD,:DWORD
; procs for control settings
InitCLPGControl    PROTO :DWORD

SetControlColor    PROTO :DWORD,:DWORD,:DWORD
SetControlNewValue PROTO :DWORD,:DWORD
SetCtrlFontSize    PROTO :DWORD,:DWORD
SetControlRange    PROTO :DWORD,:SDWORD,:SDWORD
SetControlStep     PROTO :DWORD,:DWORD
SetControlStepIt   PROTO :DWORD,:DWORD
ClpgInitStandard   PROTO :DWORD
DrawGDIp           PROTO :DWORD




; CONSTANTS ---------------------------------------------------

WM_CLPG_NEW_DATA                EQU WM_USER + 100h

CLPG_BACKCOLOR                  EQU 0h
CLPG_COLOR000                   EQU 1h
CLPG_COLOR050                   EQU 2h
CLPG_COLOR100                   EQU 3h
CLPG_TEXTCOLOR                  EQU 4h

CPLG_INFO_CUSTOMFORECOLORS      EQU 1h
CPLG_INFO_CUSTOMBACKCOLOR       EQU 2h
CPLG_INFO_CUSTOMFONTSIZE        EQU 4h
CPLG_INFO_CUSTOMRANGE           EQU 8h
CPLG_INFO_CUSTOMSTEP            EQU 10h

;ComputerNameDnsFullyQualified   EQU 0003h

CpuPgBar STRUCT

    ;--- Window (control) handle
    hWndCtrl             HWND ?         ; Control handle
    ;--- Color variables
	dwColor000           DWORD ?        ; Color at 0 %
	dwColor050           DWORD ?        ; Color at 50 %
	dwColor100           DWORD ?        ; Color at 100 %
	dwColorBckgr         DWORD ?        ; Background color
	dwColorText          DWORD ?        ; Text color
	;--- Control settings
    dwStyle              DWORD ?        ; Control style
    dwCustomInfo         DWORD ?        ; Flags for customized infos (i.e. custom colors)
	dwMinVal             SDWORD ?		; Minimum Value
	dwMaxVal             SDWORD ?		; Maximum value
	dwRange              DWORD ?        ; MaxVal - MinVal
	dwValue		         DWORD ?        ; Current value
	dwRelPos             DWORD ?        ; Postion to draw
	dwStep               DWORD ?        ; Step size for WM_CLPG_STEPIT
	dwFontSize           DWORD ?        ; Fontsize (in percent)
    ;--- PDH Counter variables
    hQuery               HANDLE ?       ; Pdh query handle
    hCounter	         HANDLE ?       ; Pdh counter handle
    ;--- Timer variables
    TimerID              DWORD ?		; TimerID 
    uElapse              DWORD ?        ; Timer setting (uElapse) 
    ;--- Gdi+ variables
    hGraphics            HANDLE ?       ; handle to GDI+ graphics class
    hLGraphics           HANDLE ?
    hBitmap              HANDLE ?       ; handle to GDI+ bitmap class
    hFontFam             HANDLE ?       ; handle to font family class
    hCurFont             HANDLE ?       ; handle to selected font
    hBrush               HANDLE ?		; handle to background brush
    htBrush              HANDLE ?		; handle to texture brush
    hStringBrush         HANDLE ?       ; handle to string brush
    hPen                 HANDLE ?
    ;--- String variables
    dwStrLen             DWORD ?        ; Length [chars] of string displayed in control    
    szBuffer             DB 32 DUP (?)  ; Buffer for ansi string
    szWBuffer            WORD 32 DUP (?); Buffer for string displayed in control (unicode)  
    szwFontName          WORD 36 DUP (?); Buffer for font name (unicode)                                                                       
CpuPgBar ends

.Data

fWidth                   REAL4 1.0
dwControlCount           DWORD 0
GdiPlusSI                GdiplusStartupInput <1,NULL,FALSE,FALSE>
hGDIplus                 DWORD 0        ; token
szInstName	             DB "0",0		;
;szInstName1	             DB "_Total",0  ; Phd instance name
szControlClass		     DB "ctrlCPULoad",0
WSTR                     szwFont,"Arial"