
PDH_MAX_COUNTER_PATH               EQU 0800h
PDH_FMT_LONG                       EQU 0100h

PERF_DATA_VERSION                  EQU 1
PERF_DATA_REVISION                 EQU 1
PERF_NO_INSTANCES                  EQU -1
PERF_SIZE_DWORD                    EQU 0h
PERF_SIZE_LARGE                    EQU 100h
PERF_SIZE_ZERO                     EQU 200h
PERF_SIZE_VARIABLE_LEN             EQU 300h
PERF_TYPE_NUMBER                   EQU 0h
PERF_TYPE_COUNTER                  EQU 400h
PERF_TYPE_TEXT                     EQU 800h
PERF_TYPE_ZERO                     EQU 0C00h
PERF_NUMBER_HEX                    EQU 0h
PERF_NUMBER_DECIMAL                EQU 10000h
PERF_NUMBER_DEC_1000               EQU 20000h
PERF_COUNTER_VALUE                 EQU 0h
PERF_COUNTER_RATE                  EQU 10000h
PERF_COUNTER_FRACTION              EQU 20000h
PERF_COUNTER_BASE                  EQU 30000h
PERF_COUNTER_ELAPSED               EQU 40000h
PERF_COUNTER_QUEUELEN              EQU 50000h
PERF_COUNTER_HISTOGRAM             EQU 60000h
PERF_TEXT_UNICODE                  EQU 0h
PERF_TEXT_ASCII                    EQU 10000h
PERF_TIMER_TICK                    EQU 0h
PERF_TIMER_100NS                   EQU 100000h
PERF_OBJECT_TIMER                  EQU 200000h
PERF_DELTA_COUNTER                 EQU 400000h
PERF_DELTA_BASE                    EQU 800000h
PERF_INVERSE_COUNTER               EQU 1000000h
PERF_MULTI_COUNTER                 EQU 2000000h
PERF_DISPLAY_NO_SUFFIX             EQU 0h
PERF_DISPLAY_PER_SEC               EQU 10000000h
PERF_DISPLAY_PERCENT               EQU 20000000h
PERF_DISPLAY_SECONDS               EQU 30000000h
PERF_DISPLAY_NOSHOW                EQU 40000000h
PERF_COUNTER_COUNTER               EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_TICK OR PERF_DELTA_COUNTER OR PERF_DISPLAY_PER_SEC
PERF_COUNTER_TIMER                 EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_TICK OR PERF_DELTA_COUNTER OR PERF_DISPLAY_PERCENT
PERF_COUNTER_QUEUELEN_TYPE         EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_QUEUELEN OR PERF_TIMER_TICK OR PERF_DELTA_COUNTER OR PERF_DISPLAY_NO_SUFFIX
PERF_COUNTER_BULK_COUNT            EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_TICK OR PERF_DELTA_COUNTER OR PERF_DISPLAY_PER_SEC
PERF_COUNTER_TEXT                  EQU PERF_SIZE_VARIABLE_LEN OR PERF_TYPE_TEXT OR PERF_TEXT_UNICODE OR PERF_DISPLAY_NO_SUFFIX
PERF_COUNTER_RAWCOUNT              EQU PERF_SIZE_DWORD OR PERF_TYPE_NUMBER OR PERF_NUMBER_DECIMAL OR PERF_DISPLAY_NO_SUFFIX
PERF_SAMPLE_FRACTION               EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_FRACTION OR PERF_DELTA_COUNTER OR PERF_DELTA_BASE OR PERF_DISPLAY_PERCENT
PERF_SAMPLE_COUNTER                EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_TICK OR PERF_DELTA_COUNTER OR PERF_DISPLAY_NO_SUFFIX
PERF_COUNTER_NODATA                EQU PERF_SIZE_ZERO OR PERF_DISPLAY_NOSHOW
PERF_COUNTER_TIMER_INV             EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_TICK OR PERF_DELTA_COUNTER OR PERF_INVERSE_COUNTER OR PERF_DISPLAY_PERCENT
PERF_SAMPLE_BASE                   EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_BASE OR PERF_DISPLAY_NOSHOW OR 1h
PERF_AVERAGE_TIMER                 EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_FRACTION OR PERF_DISPLAY_SECONDS
PERF_AVERAGE_BASE                  EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_BASE OR PERF_DISPLAY_NOSHOW OR 2h
PERF_AVERAGE_BULK                  EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_FRACTION OR PERF_DISPLAY_NOSHOW
PERF_100NSEC_TIMER                 EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_100NS OR PERF_DELTA_COUNTER OR PERF_DISPLAY_PERCENT
PERF_100NSEC_TIMER_INV             EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_100NS OR PERF_DELTA_COUNTER OR PERF_INVERSE_COUNTER OR PERF_DISPLAY_PERCENT
PERF_COUNTER_MULTI_TIMER           EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_DELTA_COUNTER OR PERF_TIMER_TICK OR PERF_MULTI_COUNTER OR PERF_DISPLAY_PERCENT
PERF_COUNTER_MULTI_TIMER_INV       EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_RATE OR PERF_DELTA_COUNTER OR PERF_MULTI_COUNTER OR PERF_TIMER_TICK OR PERF_INVERSE_COUNTER OR PERF_DISPLAY_PERCENT
PERF_COUNTER_MULTI_BASE            EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_BASE OR PERF_MULTI_COUNTER OR PERF_DISPLAY_NOSHOW
PERF_100NSEC_MULTI_TIMER           EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_DELTA_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_100NS OR PERF_MULTI_COUNTER OR PERF_DISPLAY_PERCENT
PERF_100NSEC_MULTI_TIMER_INV       EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_DELTA_COUNTER OR PERF_COUNTER_RATE OR PERF_TIMER_100NS OR PERF_MULTI_COUNTER OR PERF_INVERSE_COUNTER OR PERF_DISPLAY_PERCENT
PERF_RAW_FRACTION                  EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_FRACTION OR PERF_DISPLAY_PERCENT
PERF_RAW_BASE                      EQU PERF_SIZE_DWORD OR PERF_TYPE_COUNTER OR PERF_COUNTER_BASE OR PERF_DISPLAY_NOSHOW OR 3h
PERF_ELAPSED_TIME                  EQU PERF_SIZE_LARGE OR PERF_TYPE_COUNTER OR PERF_COUNTER_ELAPSED OR PERF_OBJECT_TIMER OR PERF_DISPLAY_SECONDS
PERF_COUNTER_HISTOGRAM_TYPE        EQU 80000000h
PERF_DETAIL_NOVICE                 EQU 100
PERF_DETAIL_ADVANCED               EQU 200
PERF_DETAIL_EXPERT                 EQU 300
PERF_DETAIL_WIZARD                 EQU 400
PERF_NO_UNIQUE_ID                  EQU -1


; PdhMakeCounterPath: [PDH_COUNTER_PATH_ELEMENTS]
; If a rEQUired member is not present, then no path string will be constructed.
; If the szMachineName member is NULL, then no computer name will be included in the path
; (a generic path will be created). If the instance name argument is NULL, then no instance
; reference will be inserted into the path string and the szParentInstance and the
; dwInstanceIndex members will be ignored.

PDH_COUNTER_PATH_ELEMENTS STRUCT
	szMachineName		DWORD ?		; optional - Pointer to a null-terminated string that specifies the computer name.
	szObjectName		DWORD ?		; required - Pointer to a null-terminated string that specifies the object name.
	szInstanceName		DWORD ?		; optional - Pointer to a null-terminated string that specifies the instance name.
	szParentInstance	DWORD ?		; optional - Pointer to a null-terminated string that specifies the parent instance name.
	dwInstanceIndex		DWORD ?		; optional - Index of duplicate instance names.
	szCounterName		DWORD ?		; required - to a null-terminated string that specifies the counter name.
	szFillBytes			BYTE PDH_MAX_COUNTER_PATH DUP (?)
PDH_COUNTER_PATH_ELEMENTS ENDS

PDH_FMT_COUNTERVALUE STRUCT
    CStatus				DWORD ?
    unionPadding		DWORD ?
    longValue			DWORD ?
    extraBytes			DWORD ?
PDH_FMT_COUNTERVALUE ENDS


; PDH Error Codes:

PDH_CSTATUS_VALID_DATA				EQU	000000000h	; The returned data is valid.
PDH_CSTATUS_NEW_DATA				EQU	000000001h	; The return data value is valid and different from the last sample.
PDH_CSTATUS_NO_MACHINE				EQU	0800007D0h	; Unable to connect to specified machine or machine is off line.
PDH_CSTATUS_NO_INSTANCE				EQU	0800007D1h	; The specified instance is not present.
PDH_MORE_DATA						EQU	0800007D2h	; There is more data to return than would fit in the supplied buffer. Allocate a larger buffer and call the function again.
PDH_CSTATUS_ITEM_NOT_VALIDATED		EQU	0800007D3h	; The data item has been added to the query but has not been validated nor accessed. No other status information on this data item is available.
PDH_RETRY							EQU	0800007D4h	; The selected operation should be retried.
PDH_NO_DATA							EQU	0800007D5h	; No data to return.
PDH_CALC_NEGATIVE_DENOMINATOR		EQU	0800007D6h	; A counter with a negative denominator value was detected.
PDH_CALC_NEGATIVE_TIMEBASE			EQU	0800007D7h	; A counter with a negative time base value was detected.
PDH_CALC_NEGATIVE_VALUE				EQU	0800007D8h	; A counter with a negative value was detected.
PDH_DIALOG_CANCELLED				EQU	0800007D9h	; The user canceled the dialog box.
PDH_END_OF_LOG_FILE					EQU	0800007DAh	; The end of the log file was reached.
PDH_ASYNC_QUERY_TIMEOUT				EQU	0800007DBh	; Time out while waiting for asynchronous counter collection thread to end.
PDH_CANNOT_SET_DEFAULT_REALTIME_DATASOURCE	EQU	0800007DCh	; Cannot change set default real-time data source. There are real-time query sessions collecting counter data.
PDH_CSTATUS_NO_OBJECT				EQU	0C0000BB8h	; The specified object is not found on the system.
PDH_CSTATUS_NO_COUNTER				EQU	0C0000BB9h	; The specified counter could not be found.
PDH_CSTATUS_INVALID_DATA			EQU	0C0000BBAh	; The returned data is not valid.
PDH_MEMORY_ALLOCATION_FAILURE		EQU	0C0000BBBh	; A PDH function could not allocate enough temporary memory to complete the operation. Close some applications or extend the page file and retry the function.
PDH_INVALID_HANDLE					EQU	0C0000BBCh	; The handle is not a valid PDH object.
PDH_INVALID_ARGUMENT				EQU	0C0000BBDh	; A required argument is missing or incorrect.
PDH_FUNCTION_NOT_FOUND				EQU	0C0000BBEh	; Unable to find the specified function.
PDH_CSTATUS_NO_COUNTERNAME			EQU	0C0000BBFh	; No counter was specified.
PDH_CSTATUS_BAD_COUNTERNAME			EQU	0C0000BC0h	; Unable to parse the counter path. Check the format and syntax of the specified path.
PDH_INVALID_BUFFER					EQU	0C0000BC1h	; The buffer passed by the caller is invalid.
PDH_INSUFFICIENT_BUFFER				EQU	0C0000BC2h	; The requested data is larger than the buffer supplied. Unable to return the rEQUested data.
PDH_CANNOT_CONNECT_MACHINE			EQU	0C0000BC3h	; Unable to connect to the requested machine.
PDH_INVALID_PATH					EQU	0C0000BC4h	; The specified counter path could not be interpreted.
PDH_INVALID_INSTANCE				EQU	0C0000BC5h	; The instance name could not be read from the specified counter path.
PDH_INVALID_DATA					EQU	0C0000BC6h	; The data is not valid.
PDH_NO_DIALOG_DATA					EQU	0C0000BC7h	; The dialog box data block was missing or invalid.
PDH_CANNOT_READ_NAME_STRINGS		EQU	0C0000BC8h	; Unable to read the counter and/or explain text from the specified machine.
PDH_LOG_FILE_CREATE_ERROR			EQU	0C0000BC9h	; Unable to create the specified log file.
PDH_LOG_FILE_OPEN_ERROR				EQU	0C0000BCAh	; Unable to open the specified log file.
PDH_LOG_TYPE_NOT_FOUND				EQU	0C0000BCBh	; The specified log file type has not been installed on this system.
PDH_NO_MORE_DATA					EQU	0C0000BCCh	; No more data is available.
PDH_ENTRY_NOT_IN_LOG_FILE			EQU	0C0000BCDh	; The specified record was not found in the log file.
PDH_DATA_SOURCE_IS_LOG_FILE			EQU	0C0000BCEh	; The specified data source is a log file.
PDH_DATA_SOURCE_IS_REAL_TIME		EQU	0C0000BCFh	; The specified data source is the current activity.
PDH_UNABLE_READ_LOG_HEADER			EQU	0C0000BD0h	; The log file header could not be read.
PDH_FILE_NOT_FOUND					EQU	0C0000BD1h	; Unable to find the specified file.
PDH_FILE_ALREADY_EXISTS				EQU	0C0000BD2h	; There is already a file with the specified file name.
PDH_NOT_IMPLEMENTED					EQU	0C0000BD3h	; The function referenced has not been implemented.
PDH_STRING_NOT_FOUND				EQU	0C0000BD4h	; Unable to find the specified string in the list of performance name and explain text strings.
PDH_UNABLE_MAP_NAME_FILES			EQU	080000BD5h	; Unable to map to the performance counter name data files. The data will be read from the registry and stored locally.
PDH_UNKNOWN_LOG_FORMAT				EQU	0C0000BD6h	; The format of the specified log file is not recognized by the PDH DLL.
PDH_UNKNOWN_LOGSVC_COMMAND			EQU	0C0000BD7h	; The specified Log Service command value is not recognized.
PDH_LOGSVC_QUERY_NOT_FOUND			EQU	0C0000BD8h	; The specified Query from the Log Service could not be found or could not be opened.
PDH_LOGSVC_NOT_OPENED				EQU	0C0000BD9h	; The Performance Data Log Service key could not be opened. This may be due to insufficient privilege or because the service has not been installed.
PDH_WBEM_ERROR						EQU	0C0000BDAh	; An error occurred while accessing the WBEM data store.
PDH_ACCESS_DENIED					EQU	0C0000BDBh	; Unable to access the desired machine or service. Check the permissions and authentication of the log service or the interactive user session against those on the machine or service being monitored.
PDH_LOG_FILE_TOO_SMALL				EQU	0C0000BDCh	; The maximum log file size specified is too small to log the selected counters. No data will be recorded in this log file. Specify a smaller set of counters to log or a larger file size and retry this call.
PDH_INVALID_DATASOURCE				EQU	0C0000BDDh	; Cannot connect to ODBC DataSource Name.
PDH_INVALID_SQLDB					EQU	0C0000BDEh	; SQL Database does not contain a valid set of tables for Perfmon; use PdhCreateSQLTables.
PDH_NO_COUNTERS						EQU	0C0000BDFh	; No counters were found for this Perfmon SQL Log Set.
PDH_SQL_ALLOC_FAILED				EQU	0C0000BE0h	; Call to SQLAllocStmt failed with %1.
PDH_SQL_ALLOCCON_FAILED				EQU	0C0000BE1h	; Call to SQLAllocConnect failed with %1.
PDH_SQL_EXEC_DIRECT_FAILED			EQU	0C0000BE2h	; Call to SQLExecDirect failed with %1.
PDH_SQL_FETCH_FAILED				EQU	0C0000BE3h	; Call to SQLFetch failed with %1.
PDH_SQL_ROWCOUNT_FAILED				EQU	0C0000BE4h	; Call to SQLRowCount failed with %1.
PDH_SQL_MORE_RESULTS_FAILED			EQU	0C0000BE5h	; Call to SQLMoreResults failed with %1.
PDH_SQL_CONNECT_FAILED				EQU	0C0000BE6h	; Call to SQLConnect failed with %1.
PDH_SQL_BIND_FAILED					EQU	0C0000BE7h	; Call to SQLBindCol failed with %1.
PDH_CANNOT_CONNECT_WMI_SERVER		EQU	0C0000BE8h	; Unable to connect to the WMI server on rEQUested machine.
PDH_PLA_COLLECTION_ALREADY_RUNNING	EQU	0C0000BE9h	; Collection "%1!s!" is already running.
PDH_PLA_ERROR_SCHEDULE_OVERLAP		EQU	0C0000BEAh	; The specified start time is after the end time.
PDH_PLA_COLLECTION_NOT_FOUND		EQU	0C0000BEBh	; Collection "%1!s!" does not exist.
PDH_PLA_ERROR_SCHEDULE_ELAPSED		EQU	0C0000BECh	; The specified end time has already elapsed.
PDH_PLA_ERROR_NOSTART				EQU	0C0000BEDh	; Collection "%1!s!" did not start check the application event log for any errors.
PDH_PLA_ERROR_ALREADY_EXISTS		EQU	0C0000BEEh	; Collection "%1!s!" already exists.
PDH_PLA_ERROR_TYPE_MISMATCH			EQU	0C0000BEFh	; There is a mismatch in the settings type.
PDH_PLA_ERROR_FILEPATH				EQU	0C0000BF0h	; The information specified does not resolve to a valid path name.
PDH_PLA_SERVICE_ERROR				EQU	0C0000BF1h	; The "Performance Logs & Alerts" service did not respond.
PDH_PLA_VALIDATION_ERROR			EQU	0C0000BF2h	; The information passed is not valid.
PDH_PLA_VALIDATION_WARNING			EQU	080000BF3h	; The information passed is not valid.
PDH_PLA_ERROR_NAME_TOO_LONG			EQU	0C0000BF4h	; The name supplied is too long.
PDH_INVALID_SQL_LOG_FORMAT			EQU	0C0000BF5h	; SQL log format is incorrect. Correct format is "SQL:<DSN-name>!<LogSet-Name>".
PDH_COUNTER_ALREADY_IN_QUERY		EQU	0C0000BF6h	; Performance counter in PdhAddCounter call has already been added in the performance query. This counter is ignored.
PDH_BINARY_LOG_CORRUPT				EQU	0C0000BF7h	; Unable to read counter information and data from input binary log files.
PDH_LOG_SAMPLE_TOO_SMALL			EQU	0C0000BF8h	; At least one of the input binary log files contain fewer than two data samples.
PDH_OS_LATER_VERSION				EQU	0C0000BF9h	; The version of the operating system on the computer named %1 is later than that on the local computer. This operation is not available from the local computer.
PDH_OS_EARLIER_VERSION				EQU	0C0000BFAh	; supports %2 or later. Check the operating system version on the computer named %3.
PDH_INCORRECT_APPEND_TIME			EQU	0C0000BFBh	; The output file must contain earlier data than the file to be appended.
PDH_UNMATCHED_APPEND_COUNTER		EQU	0C0000BFCh	; Both files must have identical counters in order to append.
PDH_SQL_ALTER_DETAIL_FAILED			EQU	0C0000BFDh	; Cannot alter CounterDetail table layout in SQL database.
PDH_QUERY_PERF_DATA_TIMEOUT			EQU	0C0000BFEh	; System is busy. Timeout when collecting counter data. Please retry later or increase the CollectTime registry value.
